#include "IIC.h"

void delay5us()		
{

}

void delay_slow(unsigned int x)
{
	while(x--);
}

void I2C_init()				   //ʼ
{
	SDA = 1;
	_nop_();
	SCL = 1;
	_nop_();                //ʱ߾Ϊߵƽ	 
}

/*I2Cͨʼź*/
void I2C_start()
{
	SCL = 1;   //ʱ߿ȨȰSCL
	_nop_();   //ȶһ
	SDA = 1;   //SDAߣԱ㷢ʼźţȷǷΪߣ
	delay5us();//ͨЭ涨ʱ4.7us
	SDA = 0;   //SDAߣ½صʼź
	delay5us();//ͨЭ涨ʱ4us
}

void I2C_start_slow()
{
	SCL = 1;   //ʱ߿ȨȰSCL
	delay_slow(10);   //ȶһ
	SDA = 1;   //SDAߣԱ㷢ʼźţȷǷΪߣ
	delay_slow(10);//ͨЭ涨ʱ4.7us
	SDA = 0;   //SDAߣ½صʼź
	delay_slow(10);//ͨЭ涨ʱ4us
}		

/*I2Cֹͨź*/
void I2C_stop()
{
	SDA = 0;   //SDAߣԱ㷢ֹź
	_nop_();    //ȶһ
	SCL = 1;   //SCL
	delay5us();//ͨЭ涨ʱ4us
	SDA = 1;   //SDA
	delay5us();//ͨЭ涨ʱ4.7us
}

void I2C_stop_slow()
{
	SDA = 0;   //SDAߣԱ㷢ֹź
	delay_slow(10);   //ȶһ
	SCL = 1;   //SCL
	delay_slow(10);//ͨЭ涨ʱ4us
	SDA = 1;   //SDA
	delay_slow(10);//ͨЭ涨ʱ4.7us
}

/*ӻӦ*/
bit Test_ack()
{
	SCL = 1;	
	//SCLߣԱȡӻӦӦź
	delay5us();//ͨЭ涨ʱ4us
	if(SDA)	   
	//ȡSDAΪߣ˵ӻһӦź
	{
		SCL = 0;/*׼ֹͣźţʱSCLͣ
				I2C_stop();еSDAɱΪ0*/
		_nop_();//ȶ
		I2C_stop();
		return 0;//ӻӦ
	}	
	else
	//ȡSDAΪͣ˵ӻһӦź
	{
		SCL = 0;/*ʱSCLͣʱSDAݵı仯Ч
				Ϊ*/
		_nop_();//ȶ
		return 1;
	}
}

bit Test_ack_slow()
{
	SCL = 1;	
	//SCLߣԱȡӻӦӦź
	delay_slow(10);//ͨЭ涨ʱ4us
	if(SDA)	   
	//ȡSDAΪߣ˵ӻһӦź
	{
		SCL = 0;/*׼ֹͣźţʱSCLͣ
				I2C_stop();еSDAɱΪ0*/
		delay_slow(10);//ȶ
		I2C_stop();
		return 0;//ӻӦ
	}	
	else
	//ȡSDAΪͣ˵ӻһӦź
	{
		SCL = 0;/*ʱSCLͣʱSDAݵı仯Ч
				Ϊ*/
		delay_slow(10);//ȶ
		return 1;
	}
}

/*һӦź*/
void I2C_SendACK(bit ack)
{
	  SDA = ack;                  //дӦź
    SCL = 1;                    //ʱ
    delay5us();                 //ʱ
    SCL = 0;                    //ʱ
    delay5us();                 //ʱ
}

void I2C_SendACK_slow(bit ack)
{
	  SDA = ack;                  //дӦź
    SCL = 1;                    //ʱ
    delay_slow(10);                 //ʱ
    SCL = 0;                    //ʱ
    delay_slow(10);                 //ʱ
}

/*I2Cͨţһֽ*/
void I2C_send_byte(uint8_t byte)
{
	uint8_t i;//һi
	for(i = 0; i < 8; i++)//һֽ8λ8
	{
		SCL = 0;//SCLSDA仯Ч
		_nop_();//ȶ
		_nop_();
		if(byte & 0x80)//1000 0000 & byte
/*ҪݵĵǰλbyteλΪ1ִиif䣬
  ҪݵĵǰλbyteλΪ0ִиif*/
		{
			SDA = 1;   
			//ǰλbyteλΪ11ŵSDA
			_nop_();//ȶ
			_nop_();
		}	
		else
		//ǰλbyteλΪ0Ϊ1SDA0
		{
			SDA = 0;
			_nop_();//ȶ
			_nop_();
		}
		_nop_();		
		SCL = 1;//SCLߣʹӻܹSDA϶ȡǰ
		_nop_();//ȶ
		byte <<= 1;
/*ʹbyteһλԭѱ͵SDAϵλƳ
λδ͵λλΪһѭĵǰλ*/
	}
	SCL = 0;
	//֮󣬽SCLͣԱӻıSDAߣӦź
	_nop_();//ȶ
	_nop_();
	SDA = 1;//ͷ߿Ȩ
	_nop_();
	_nop_();//ȶ
}

void I2C_send_byte_slow(uint8_t byte)
{
	uint8_t i;//һi
	for(i = 0; i < 8; i++)//һֽ8λ8
	{
		SCL = 0;//SCLSDA仯Ч
		//ȶ
		delay_slow(10);
		if(byte & 0x80)//1000 0000 & byte
/*ҪݵĵǰλbyteλΪ1ִиif䣬
  ҪݵĵǰλbyteλΪ0ִиif*/
		{
			SDA = 1;   
			//ǰλbyteλΪ11ŵSDA
			_nop_();//ȶ
			delay_slow(10);
		}	
		else
		//ǰλbyteλΪ0Ϊ1SDA0
		{
			SDA = 0;
			_nop_();//ȶ
			delay_slow(10);
		}
		_nop_();		
		SCL = 1;//SCLߣʹӻܹSDA϶ȡǰ
		delay_slow(10);//ȶ
		byte <<= 1;
/*ʹbyteһλԭѱ͵SDAϵλƳ
λδ͵λλΪһѭĵǰλ*/
	}
	SCL = 0;
	//֮󣬽SCLͣԱӻıSDAߣӦź
	_nop_();//ȶ
	delay_slow(10);
	SDA = 1;//ͷ߿Ȩ
	delay_slow(10);
	_nop_();//ȶ
}
/**************************************
IIC߽һֽ
**************************************/
uint8_t I2C_read_byte()
{
    uint8_t i;
    uint8_t dat = 0;

    SDA = 1;                    //ʹڲ,׼ȡ,
    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;
        SCL = 1;                //ʱ
        delay5us();             //ʱ
        dat |= SDA;             //               
        SCL = 0;                //ʱ
        delay5us();             //ʱ
    }
    return dat;
}

uint8_t I2C_read_byte_slow()
{
    uint8_t i;
    uint8_t dat = 0;

    SDA = 1;                    //ʹڲ,׼ȡ,
    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;
        SCL = 1;                //ʱ
        delay_slow(10);             //ʱ
        dat |= SDA;             //               
        SCL = 0;                //ʱ
        delay_slow(10);             //ʱ
    }
    return dat;
}