#include "BH1750.H"
#include "IIC.h"

unsigned char BUF[8];          //ݻ

void BH1750_Delayms(int x)
{
	int y;
	for(x;x>0;x--)
		for(y=2000;y>0;y--);
}

void BH1750_Single_Write(unsigned char REG_Address)		//BH1750д
{
    I2C_start();	                  //ʼź
    I2C_send_byte(SlaveAddress);   //豸ַ+дź
		Test_ack();
    I2C_send_byte(REG_Address);    //ڲĴַ
  //BH1750_SendByte(REG_data);       //ڲĴ
		Test_ack();
    I2C_stop();                 //ֹͣź
}

void BH1750_Multiple_Read(void)    //BH1750ڲ
{   
		unsigned char i;        
    I2C_start();                          //ʼź
    I2C_send_byte(SlaveAddress+1);         //豸ַ+ź       
    for (i=0; i<3; i++)                      //ȡ6ַݣ洢BUF
    {
       BUF[i] = I2C_read_byte();          //BUF[0]洢0x32ַе
       if (i == 3)
       {
         I2C_SendACK(1);                //һҪNOACK
       }
       else
       {                
         I2C_SendACK(0);                //ӦACK
       }
   }
    I2C_stop();                         //ֹͣź
}

void BH1750_Init()		//ʼBH1750
{
  BH1750_Single_Write(0x01);  
}

unsigned int BH1750_Read_Data()
{
	 unsigned int temp;
	float dat;
    BH1750_Single_Write(0x01);   // power on
		BH1750_Single_Write(0x07);
    BH1750_Single_Write(0x10);   // H- resolution mode
		BH1750_Delayms(150);
	
		BH1750_Multiple_Read();
		
		temp=BUF[0];
		temp=(temp<<8)+BUF[1];//ϳ 
		dat=(float)temp/1.2;
	
	return dat;
}
