#ifndef _IIC_h
#define _IIC_h

#include <reg51.h>
#include <intrins.h>
#define uint8_t  unsigned char
#define uint16_t unsigned int

sbit SDA = P3^7;
sbit SCL = P3^6;
				   
void I2C_init();				//IICʼ
void I2C_start();				//IICʼź
void I2C_stop();				//IICֹź
bit Test_ack();					//մӻack
void I2C_SendACK(bit ack);		//ack=1Ӧ0Ӧ
void I2C_send_byte(uint8_t byte);	//IICһֽ
uint8_t I2C_read_byte();			//IICһֽ		

void I2C_start_slow();				//IICʼź
void I2C_stop_slow();				//IICֹź
bit Test_ack_slow();					//մӻack
void I2C_SendACK_slow(bit ack);		//ack=1Ӧ0Ӧ
void I2C_send_byte_slow(uint8_t byte);	//IICһֽ
uint8_t I2C_read_byte_slow();			//IICһֽ	
#endif
