#include "LCD1602.h"
#include  "reg51.h"
void Lcd1602_delay(unsigned int x)
{
	for(x;x>0;x--);
}

void Lcd1602_Read_Busy()           //æ⺯жbit70ִУ1ֹ
{
    unsigned char sta;      //
    LCD1602_DB = 0xff;
    LCD1602_RS = 0;
    LCD1602_RW = 1;
    do
    {
        LCD1602_EN = 1;
        sta = LCD1602_DB;
        LCD1602_EN = 0;    //ʹܣͣͷ
    }while(sta & 0x80);
}

void Lcd1602_Write_Cmd(unsigned char cmd)     //д
{
   // Read_Busy();
    LCD1602_RS = 0;
    LCD1602_RW = 0;
    LCD1602_DB = cmd;
    LCD1602_EN = 1;
				Lcd1602_delay(35);
    LCD1602_EN = 0;    
}

void Lcd1602_Write_Data(unsigned char dat)   //д
{
     // Read_Busy();
      LCD1602_RS = 1;
      LCD1602_RW = 0;
      LCD1602_DB = dat;
      LCD1602_EN = 1;
			Lcd1602_delay(35);
      LCD1602_EN = 0;
}

void LcdSetCursor(unsigned char x,unsigned char y)  //ʾ
{
    unsigned char addr;
    if(y == 0)
        addr = 0x00 + x;
    else
        addr = 0x40 + x;
    
    Lcd1602_Write_Cmd(addr|0x80);
}

//ָλʾһַ
void DisplayOneChar(unsigned char X, unsigned char Y, unsigned char DData)
{
	Y &= 0x1;
	X &= 0xF; //Xܴ15Yܴ1
	if (Y) X |= 0x40; //Ҫʾڶʱַ+0x40;
	X |= 0x80; //ָ
	Lcd1602_Write_Cmd(X); //
	Lcd1602_Write_Data(DData); //
}


void LcdShowStr(unsigned char x,unsigned char y,unsigned char *str)     //ʾַ
{
    LcdSetCursor(x,y);      //ǰַ
    while(*str != '\0')
    {
        Lcd1602_Write_Data(*str++);
    }
}

void Lcd1602_Write_ziku(unsigned char *ziku)   //д1602ֿ⣬88*5ֿ  ʹãLcd1602_Write_Data(1~8);
{
	unsigned char i,m;
	for(i=0;i<8;i++)
	{
		Lcd1602_Write_Cmd(0X40+i*8);
		for(m=0;m<8;m++)  
		{
			Lcd1602_Write_Data(ziku[i*8+m]);
		}
	}
}
void InitLcd1602()              //1602ʼ
{
    Lcd1602_Write_Cmd(0x38);    //򿪣5*8,8λ
    Lcd1602_Write_Cmd(0x0c);
    Lcd1602_Write_Cmd(0x06);
    Lcd1602_Write_Cmd(0x01);    //   
}
