#include <mini1602.h>

void mini1602_delay(unsigned int x)
{
	x*=5;
	while(x--);
}

void mini1602_Write_Cmd(unsigned char cmd)     //д
{
	LCD_RS = 0;				//ָ
	DB7=cmd & 0x80;
	DB6=cmd & 0x40;
	DB5=cmd & 0x20;
	DB4=cmd & 0x10;
	
	LCD_EN = 1;
	mini1602_delay(120);			//12us
	LCD_EN = 0;

	DB7=cmd & 0x08;
	DB6=cmd & 0x04;
	DB5=cmd & 0x02;
	DB4=cmd & 0x01;

	LCD_EN = 1;
	mini1602_delay(120);			//12us
	LCD_EN = 0;
}

void mini1602_Write_Data(unsigned char dat)    //д
{
	LCD_RS = 1;				//
	DB7=dat & 0x80;
	DB6=dat & 0x40;
	DB5=dat & 0x20;
	DB4=dat & 0x10;
	
	LCD_EN = 1;
	mini1602_delay(120);			//12us
	LCD_EN = 0;

	DB7=dat & 0x08;
	DB6=dat & 0x04;
	DB5=dat & 0x02;
	DB4=dat & 0x01;

	LCD_EN = 1;
	mini1602_delay(120);			//12us
	LCD_EN = 0;
}

void mini1602_init()		//ʼ
{
	LCD_RW	=0;
	mini1602_Write_Cmd(0x28);
	LCD_EN = 1;
	mini1602_delay(120);			//12us
	LCD_EN = 0;
	mini1602_Write_Cmd(0x28);	//ʾ
	mini1602_Write_Cmd(0x0c);
	mini1602_Write_Cmd(0x01);
	mini1602_delay(2000);
}

void LcdSetCursor(unsigned char x,unsigned char y)  //ʾ
{
    unsigned char addr;
    if(y == 0)
        addr = 0x00 + x;
    else
        addr = 0x40 + x;
    
   mini1602_Write_Cmd(addr|0x80);
}

//ָλʾһַ
void DisplayOneChar(unsigned char X, unsigned char Y, unsigned char DData)
{
	Y &= 0x1;
	X &= 0xF; //Xܴ15Yܴ1
	if (Y) X |= 0x40; //Ҫʾڶʱַ+0x40;
	X |= 0x80; //ָ
	mini1602_Write_Cmd(X); //
	mini1602_Write_Data(DData); //
}

void LcdShowStr(unsigned char x,unsigned char y,unsigned char *str)     //ʾַ
{
    LcdSetCursor(x,y);      //ǰַ
    while(*str != '\0')
    {
       mini1602_Write_Data(*str++);
    }
}
